Agora C++ API Reference for All Platforms

Public Types | Public Member Functions | Protected Member Functions | List of all members
agora::base::IAgoraServiceEx Class Referenceabstract

Inherits agora::base::IAgoraService.

## Public Types
using | ScreenCaptureType = rtc::IScreenCapturer2
using | ScreenCaptureType = rtc::IScreenCapturer

## Public Member Functions
virtual int | initialize (const rtm::RtmConfig &rtmCfg)
virtual void | set_lite_initialized (bool initialized)
virtual int | initializeLLApiInternal (const AgoraServiceConfiguration &config)=0
virtual int | initializeEx (const AgoraServiceConfigEx &context)=0
virtual agora_refptr< rtc::IRtcConnectionEx > | createRtcConnectionEx (const rtc::RtcConnectionConfigurationEx &cfg)=0
virtual int32_t | setAudioDumpPath (const char *filePath)=0
virtual rtc::IRtcConnection * | getOneRtcConnection (bool admBinded) const =0
virtual void | enableStringUid (bool enabled)=0
virtual bool | useStringUid () const =0
virtual bool | externalAudioSinkEnabled () const =0
virtual rtc::uid_t | getUidByUserAccount (const std::string &app_id, const std::string &user_account) const =0
virtual int | registerLocalUserAccount (const char *appId, const char *userAccount)=0
virtual rtc::IDiagnosticService * | getDiagnosticService () const =0
virtual int | registerAgoraServiceObserver (IAgoraServiceObserver *observer)=0
virtual int | unregisterAgoraServiceObserver (IAgoraServiceObserver *observer)=0
virtual agora_refptr< rtc::IFileUploaderService > | createFileUploadServiceEx (agora_refptr< rtc::IRtcConnection > rtcConnection, const char *appId, media::CONTENT_INSPECT_CLOUD_TYPE cloudType)=0
virtual int | releaseEngineResourceLLApiInternal ()=0
virtual int | atExitLLApiInternal ()=0
virtual int | releaseLLApiInternal ()=0
virtual int | setLogFileLLApiInternal (const char *filePath, unsigned int fileSize)=0
virtual int | setLogFilterLLApiInternal (unsigned int filters)=0
virtual agora_refptr< rtc::IRtcConnectionEx > | getRtcConnectionInChannel (const char *name, const user_id_t usrId)=0
virtual int | getConnectionCountsWithChannelId (const char *channelId)=0
virtual rtm::IRtmService * | createRtmServiceLLApiInternal ()=0
virtual int | setAudioSessionPresetLLApiInternal (rtc::AUDIO_SCENARIO_TYPE scenario)=0
virtual int | setAudioSessionConfigurationLLApiInternal (const AudioSessionConfiguration &config)=0
virtual int | getAudioSessionConfigurationLLApiInternal (AudioSessionConfiguration *config)=0
virtual agora_refptr< rtc::IRtcConnection > | createRtcConnectionLLApiInternal (const rtc::RtcConnectionConfiguration &cfg)=0
virtual agora_refptr< rtc::IRtmpConnection > | createRtmpConnectionLLApiInternal (const rtc::RtmpConnectionConfiguration &cfg)=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createLocalAudioTrackLLApiInternal ()=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createLocalMixedAudioTrackLLApiInternal ()=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createCustomAudioTrackLLApiInternal (agora_refptr< rtc::IAudioPcmDataSender > audioSource)=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createDirectCustomAudioTrackLLApiInternal (agora_refptr< rtc::IAudioPcmDataSender > audioSource, bool enableAudioProcessing)=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createCustomAudioTrackLLApiInternal (agora_refptr< rtc::IAudioPcmDataSender > audioSource, bool enableAec)=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createCustomAudioTrackLLApiInternal (agora_refptr< rtc::IRemoteAudioMixerSource > audioSource)=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createCustomAudioTrackLLApiInternal (agora_refptr< rtc::IAudioEncodedFrameSender > audioSource, TMixMode mixMode)=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createCustomAudioTrackLLApiInternal (agora_refptr< rtc::IMediaPacketSender > source)=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createMediaPlayerAudioTrackLLApiInternal (agora_refptr< rtc::IMediaPlayerSource > playerSource)=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createMediaStreamingAudioTrackLLApiInternal (agora_refptr< rtc::IMediaStreamingSource > streamingSource)=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createRecordingDeviceAudioTrackLLApiInternal (agora_refptr< rtc::IRecordingDeviceSource > audioSource, bool enableAec, bool overlap)=0
virtual agora_refptr< rtc::INGAudioDeviceManager > | createAudioDeviceManagerLLApiInternal ()=0
virtual agora_refptr< rtc::IMediaNodeFactoryEx > | createMediaNodeFactoryLLApiInternal ()=0
virtual agora_refptr< rtc::ILocalVideoTrackEx > | createCameraVideoTrackLLApiInternal (agora_refptr< rtc::ICameraCapturer > videoSource, const char *track_id)=0
virtual agora_refptr< rtc::ILocalVideoTrackEx > | createMixedVideoTrackLLApiInternal (agora_refptr< rtc::IVideoMixerSource > videoSource, const char *id)=0
virtual agora_refptr< rtc::ILocalVideoTrackEx > | createTranscodedVideoTrackLLApiInternal (agora_refptr< rtc::IVideoFrameTransceiver > transceiver, const char *id)=0
virtual agora_refptr< rtc::ILocalVideoTrackEx > | createCustomVideoTrackLLApiInternal (agora_refptr< rtc::IVideoFrameSender > videoSource, const char *id)=0
virtual agora_refptr< rtc::ILocalVideoTrackEx > | createCustomVideoTrackLLApiInternal (agora_refptr< rtc::IVideoEncodedImageSender > videoSource, const rtc::SenderOptions &options, const char *id=nullptr)=0
virtual agora_refptr< rtc::ILocalVideoTrackEx > | createCustomVideoTrackLLApiInternal (agora_refptr< rtc::IMediaPacketSender > source, const char *id=nullptr)=0
virtual agora_refptr< rtc::ILocalVideoTrackEx > | createScreenCaptureVideoTrackLLApiInternal (agora_refptr< rtc::IScreenCapturer2 > screen)=0
virtual agora_refptr< rtc::ILocalVideoTrackEx > | createScreenCaptureVideoTrackLLApiInternal (agora_refptr< rtc::IScreenCapturer > screen, const char *id)=0
virtual agora_refptr< rtc::ILocalAudioTrackEx > | createScreenCaptureAudioTrackLLApiInternal (agora_refptr< ScreenCaptureType > screen)=0
virtual agora_refptr< rtc::ILocalVideoTrackEx > | createMediaPlayerVideoTrackLLApiInternal (agora_refptr< rtc::IMediaPlayerSource > playerVideoSource, const char *id=nullptr)=0
virtual agora_refptr< rtc::ILocalVideoTrackEx > | createMediaStreamingVideoTrackLLApiInternal (agora_refptr< rtc::IMediaStreamingSource > streamingSource, const char *id=nullptr)=0
virtual agora_refptr< rtc::IRtmpStreamingService > | createRtmpStreamingServiceLLApiInternal (agora_refptr< rtc::IRtcConnection > rtcConnection, const char *appId)=0
virtual agora_refptr< rtc::IMediaRelayService > | createMediaRelayServiceLLApiInternal (agora_refptr< rtc::IRtcConnection > rtcConnection, const char *appId)=0
virtual agora_refptr< rtc::IAudioDeviceManager > | createAudioDeviceManagerComponentLLApiInternal (rtc::IAudioDeviceManagerObserver *observer)=0
virtual agora_refptr< rtc::IFileUploaderService > | createFileUploadServiceLLApiInternal (agora_refptr< rtc::IRtcConnection > rtcConnection, const char *appId)=0
virtual agora_refptr< ILocalDataChannel > | createLocalDataChannelLLApiInternal (const DataChannelConfig &config)=0
virtual agora_refptr< rtc::IConfigCenter > | getConfigCenterLLApiInternal ()=0
virtual agora_refptr< base::ISyncClientEx > | createSyncClientLLApiInternal (const SyncConfig &config)=0
virtual int | addExtensionObserverLLApiInternal (agora::agora_refptr< agora::rtc::IMediaExtensionObserver > observer)=0
virtual int | removeExtensionObserverLLApiInternal (agora::agora_refptr< agora::rtc::IMediaExtensionObserver > observer)=0
virtual const char * | getExtensionIdLLApiInternal (const char *provider_name, const char *extension_name)=0
virtual int | enableExtensionLLApiInternal (const char *provider_name, const char *extension_name, const char *track_id, bool auto_enable_on_track)=0
virtual int | disableExtensionLLApiInternal (const char *provider_name, const char *extension_name, const char *track_id)=0
virtual int | startTrace (uint32_t count, uint64_t mask)=0
virtual int | stopTrace (const char *file_path)=0
virtual int | setExternalAudioSink (bool enabled, int sampleRate, int channels)=0
virtual int | pullPlaybackAudioPcmData (void *payloadData, const rtc::AudioPcmDataInfo &audioFrameInfo)=0
virtual aosl_ref_t | createRhythmPlayer ()=0
virtual int | destroyRhythmPlayer (aosl_ref_t ref_id)=0
virtual aosl_ref_t | createMediaPlayer (media::base::MEDIA_PLAYER_SOURCE_TYPE type)=0
virtual int | destroyMediaPlayer (aosl_ref_t ref_id)=0
virtual int | unregisterServiceEventObserver (IServiceObserver *observer)=0
virtual commons::io_engine_base * | getIoEngine ()=0
virtual int | setExternalRemoteEglContext (void *eglContext)=0
virtual int | initialize (const AgoraServiceConfiguration &config)=0
Public Member Functions inherited from agora::base::IAgoraService
virtual int | initialize (const AgoraServiceConfiguration &config)=0
virtual int | atExit (aosl_ref_t ares=AOSL_REF_INVALID)=0
virtual int | release ()=0
virtual int | setAudioSessionPreset (agora::rtc::AUDIO_SCENARIO_TYPE scenario, aosl_ref_t ares=AOSL_REF_INVALID)=0
virtual int | setAudioSessionConfiguration (const AudioSessionConfiguration &config, aosl_ref_t ares=AOSL_REF_INVALID)=0
virtual int | getAudioSessionConfiguration (AudioSessionConfiguration *config)=0
virtual int | setLogFile (const char *filePath, unsigned int fileSize, aosl_ref_t ares=AOSL_REF_INVALID)=0
virtual int | setLogFilter (unsigned int filters, aosl_ref_t ares=AOSL_REF_INVALID)=0
virtual agora_refptr< rtc::IRtcConnection > | createRtcConnection (const rtc::RtcConnectionConfiguration &cfg)=0
virtual agora_refptr< rtc::IRtmpConnection > | createRtmpConnection (const rtc::RtmpConnectionConfiguration &cfg)=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createLocalAudioTrack ()=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createLocalMixedAudioTrack ()=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createCustomAudioTrack (agora_refptr< rtc::IAudioPcmDataSender > audioSource)=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createDirectCustomAudioTrack (agora_refptr< rtc::IAudioPcmDataSender > audioSource)=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createCustomAudioTrack (agora_refptr< rtc::IAudioPcmDataSender > audioSource, bool enableAec)=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createCustomAudioTrack (agora_refptr< rtc::IRemoteAudioMixerSource > audioSource)=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createCustomAudioTrack (agora_refptr< rtc::IAudioEncodedFrameSender > audioSource, TMixMode mixMode)=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createCustomAudioTrack (agora_refptr< rtc::IMediaPacketSender > source)=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createMediaPlayerAudioTrack (agora_refptr< rtc::IMediaPlayerSource > audioSource)=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createMediaStreamingAudioTrack (agora_refptr< rtc::IMediaStreamingSource > streamingSource)=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createRecordingDeviceAudioTrack (agora_refptr< rtc::IRecordingDeviceSource > audioSource, bool enableAec, bool overlap)=0
virtual agora_refptr< rtc::INGAudioDeviceManager > | createAudioDeviceManager ()=0
virtual agora_refptr< rtc::IMediaNodeFactory > | createMediaNodeFactory ()=0
virtual agora_refptr< rtc::ILocalVideoTrack > | createCameraVideoTrack (agora_refptr< rtc::ICameraCapturer > videoSource, const char *id=OPTIONAL_NULLPTR)=0
virtual agora_refptr< rtc::ILocalVideoTrack > | createMixedVideoTrack (agora_refptr< rtc::IVideoMixerSource > videoSource, const char *id=OPTIONAL_NULLPTR)=0
virtual agora_refptr< rtc::ILocalVideoTrack > | createTranscodedVideoTrack (agora_refptr< rtc::IVideoFrameTransceiver > transceiver, const char *id=OPTIONAL_NULLPTR)=0
virtual agora_refptr< rtc::ILocalVideoTrack > | createCustomVideoTrack (agora_refptr< rtc::IVideoFrameSender > videoSource, const char *id=OPTIONAL_NULLPTR)=0
virtual agora_refptr< rtc::ILocalVideoTrack > | createCustomVideoTrack (agora_refptr< rtc::IVideoEncodedImageSender > videoSource, const rtc::SenderOptions &options, const char *id=OPTIONAL_NULLPTR)=0
virtual agora_refptr< rtc::ILocalVideoTrack > | createScreenCaptureVideoTrack (agora_refptr< rtc::IScreenCapturer2 > screen)=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createScreenCaptureAudioTrack (agora_refptr< rtc::IScreenCapturer2 > screen)=0
virtual agora_refptr< rtc::ILocalVideoTrack > | createScreenCaptureVideoTrack (agora_refptr< rtc::IScreenCapturer > screen, const char *id=OPTIONAL_NULLPTR)=0
virtual agora_refptr< rtc::ILocalAudioTrack > | createScreenCaptureAudioTrack (agora_refptr< rtc::IScreenCapturer > screen)=0
virtual agora_refptr< rtc::ILocalVideoTrack > | createCustomVideoTrack (agora_refptr< rtc::IMediaPacketSender > source, const char *id=OPTIONAL_NULLPTR)=0
virtual agora_refptr< rtc::ILocalVideoTrack > | createMediaPlayerVideoTrack (agora_refptr< rtc::IMediaPlayerSource > videoSource, const char *id=OPTIONAL_NULLPTR)=0
virtual agora_refptr< rtc::ILocalVideoTrack > | createMediaStreamingVideoTrack (agora_refptr< rtc::IMediaStreamingSource > streamingSource, const char *id=OPTIONAL_NULLPTR)=0
virtual agora_refptr< rtc::IRtmpStreamingService > | createRtmpStreamingService (agora_refptr< rtc::IRtcConnection > rtcConnection, const char *appId)=0
virtual agora_refptr< rtc::IMediaRelayService > | createMediaRelayService (agora_refptr< rtc::IRtcConnection > rtcConnection, const char *appId)=0
virtual agora_refptr< rtc::IFileUploaderService > | createFileUploadService (agora_refptr< rtc::IRtcConnection > rtcConnection, const char *appId)=0
virtual rtm::IRtmService * | createRtmService ()=0
virtual int | addExtensionObserver (agora::agora_refptr< agora::rtc::IMediaExtensionObserver > observer, aosl_ref_t ares=AOSL_REF_INVALID)=0
virtual int | removeExtensionObserver (agora::agora_refptr< agora::rtc::IMediaExtensionObserver > observer, aosl_ref_t ares=AOSL_REF_INVALID)=0
virtual agora_refptr< rtc::IAudioDeviceManager > | createAudioDeviceManagerComponent (rtc::IAudioDeviceManagerObserver *observer)=0
virtual agora_refptr< ILocalDataChannel > | createLocalDataChannel (const DataChannelConfig &config)=0
virtual const char * | getExtensionId (const char *provider_name, const char *extension_name)=0
virtual int | loadExtensionProvider (const char *path, bool unload_after_use=false)=0
virtual int | enableExtension (const char *provider_name, const char *extension_name, const char *track_id=NULL, bool auto_enable_on_track=false, aosl_ref_t ares=AOSL_REF_INVALID)=0
virtual int | disableExtension (const char *provider_name, const char *extension_name, const char *track_id=NULL, aosl_ref_t ares=AOSL_REF_INVALID)=0
virtual agora_refptr< base::IAgoraParameter > | getAgoraParameter ()=0
virtual agora_refptr< rtc::IConfigCenter > | getConfigCenter ()=0
virtual agora_refptr< base::ISyncClient > | createSyncClient (const base::SyncConfig &config)=0
virtual int32_t | setLogWriter (agora::commons::ILogWriter *logWriter)=0
virtual agora::commons::ILogWriter * | releaseLogWriter ()=0

## Protected Member Functions
virtual | ~IAgoraServiceEx ()
Protected Member Functions inherited from agora::base::IAgoraService
virtual | ~IAgoraService ()

## Member Typedef Documentation

## ◆ ScreenCaptureType [1/2]

using agora::base::IAgoraServiceEx::ScreenCaptureType = rtc::IScreenCapturer2

## ◆ ScreenCaptureType [2/2]

using agora::base::IAgoraServiceEx::ScreenCaptureType = rtc::IScreenCapturer

## Constructor & Destructor Documentation

## ◆ ~IAgoraServiceEx()

virtual agora::base::IAgoraServiceEx::~IAgoraServiceEx | ( |  | ) |
| inline protected virtual

## Member Function Documentation

## ◆ initialize() [1/2]

virtual int agora::base::IAgoraServiceEx::initialize | ( | const rtm::RtmConfig & | rtmCfg | ) |
| inline virtual

## ◆ set_lite_initialized()

virtual void agora::base::IAgoraServiceEx::set_lite_initialized | ( | bool | initialized | ) |
| inline virtual

## ◆ initializeLLApiInternal()

virtual int agora::base::IAgoraServiceEx::initializeLLApiInternal | ( | const AgoraServiceConfiguration & | config | ) |
| pure virtual

## ◆ initializeEx()

virtual int agora::base::IAgoraServiceEx::initializeEx | ( | const AgoraServiceConfigEx & | context | ) |
| pure virtual

## ◆ createRtcConnectionEx()

virtual agora_refptr<rtc::IRtcConnectionEx> agora::base::IAgoraServiceEx::createRtcConnectionEx | ( | const rtc::RtcConnectionConfigurationEx & | cfg | ) |
| pure virtual

## ◆ setAudioDumpPath()

virtual int32_t agora::base::IAgoraServiceEx::setAudioDumpPath | ( | const char * | filePath | ) |
| pure virtual

## ◆ getOneRtcConnection()

virtual rtc::IRtcConnection* agora::base::IAgoraServiceEx::getOneRtcConnection | ( | bool | admBinded | ) | const
| pure virtual

## ◆ enableStringUid()

virtual void agora::base::IAgoraServiceEx::enableStringUid | ( | bool | enabled | ) |
| pure virtual

## ◆ useStringUid()

virtual bool agora::base::IAgoraServiceEx::useStringUid | ( |  | ) | const
| pure virtual

## ◆ externalAudioSinkEnabled()

virtual bool agora::base::IAgoraServiceEx::externalAudioSinkEnabled | ( |  | ) | const
| pure virtual

## ◆ getUidByUserAccount()

virtual rtc::uid_t agora::base::IAgoraServiceEx::getUidByUserAccount | ( | const std::string & | app_id,
|  | const std::string & | user_account
| ) |  | const
| pure virtual

## ◆ registerLocalUserAccount()

virtual int agora::base::IAgoraServiceEx::registerLocalUserAccount | ( | const char * | appId,
|  | const char * | userAccount
| ) |  |
| pure virtual

## ◆ getDiagnosticService()

virtual rtc::IDiagnosticService* agora::base::IAgoraServiceEx::getDiagnosticService | ( |  | ) | const
| pure virtual

## ◆ registerAgoraServiceObserver()

virtual int agora::base::IAgoraServiceEx::registerAgoraServiceObserver | ( | IAgoraServiceObserver * | observer | ) |
| pure virtual

## ◆ unregisterAgoraServiceObserver()

virtual int agora::base::IAgoraServiceEx::unregisterAgoraServiceObserver | ( | IAgoraServiceObserver * | observer | ) |
| pure virtual

## ◆ createFileUploadServiceEx()

virtual agora_refptr<rtc::IFileUploaderService> agora::base::IAgoraServiceEx::createFileUploadServiceEx | ( | agora_refptr< rtc::IRtcConnection > | rtcConnection,
|  | const char * | appId,
|  | media::CONTENT_INSPECT_CLOUD_TYPE | cloudType
| ) |  |
| pure virtual

## ◆ releaseEngineResourceLLApiInternal()

virtual int agora::base::IAgoraServiceEx::releaseEngineResourceLLApiInternal | ( |  | ) |
| pure virtual

## ◆ atExitLLApiInternal()

virtual int agora::base::IAgoraServiceEx::atExitLLApiInternal | ( |  | ) |
| pure virtual

## ◆ releaseLLApiInternal()

virtual int agora::base::IAgoraServiceEx::releaseLLApiInternal | ( |  | ) |
| pure virtual

## ◆ setLogFileLLApiInternal()

virtual int agora::base::IAgoraServiceEx::setLogFileLLApiInternal | ( | const char * | filePath,
|  | unsigned int | fileSize
| ) |  |
| pure virtual

## ◆ setLogFilterLLApiInternal()

virtual int agora::base::IAgoraServiceEx::setLogFilterLLApiInternal | ( | unsigned int | filters | ) |
| pure virtual

## ◆ getRtcConnectionInChannel()

virtual agora_refptr<rtc::IRtcConnectionEx> agora::base::IAgoraServiceEx::getRtcConnectionInChannel | ( | const char * | name,
|  | const user_id_t | usrId
| ) |  |
| pure virtual

## ◆ getConnectionCountsWithChannelId()

virtual int agora::base::IAgoraServiceEx::getConnectionCountsWithChannelId | ( | const char * | channelId | ) |
| pure virtual

## ◆ createRtmServiceLLApiInternal()

virtual rtm::IRtmService* agora::base::IAgoraServiceEx::createRtmServiceLLApiInternal | ( |  | ) |
| pure virtual

## ◆ setAudioSessionPresetLLApiInternal()

virtual int agora::base::IAgoraServiceEx::setAudioSessionPresetLLApiInternal | ( | rtc::AUDIO_SCENARIO_TYPE | scenario | ) |
| pure virtual

## ◆ setAudioSessionConfigurationLLApiInternal()

virtual int agora::base::IAgoraServiceEx::setAudioSessionConfigurationLLApiInternal | ( | const AudioSessionConfiguration & | config | ) |
| pure virtual

## ◆ getAudioSessionConfigurationLLApiInternal()

virtual int agora::base::IAgoraServiceEx::getAudioSessionConfigurationLLApiInternal | ( | AudioSessionConfiguration * | config | ) |
| pure virtual

## ◆ createRtcConnectionLLApiInternal()

virtual agora_refptr<rtc::IRtcConnection> agora::base::IAgoraServiceEx::createRtcConnectionLLApiInternal | ( | const rtc::RtcConnectionConfiguration & | cfg | ) |
| pure virtual

## ◆ createRtmpConnectionLLApiInternal()

virtual agora_refptr<rtc::IRtmpConnection> agora::base::IAgoraServiceEx::createRtmpConnectionLLApiInternal | ( | const rtc::RtmpConnectionConfiguration & | cfg | ) |
| pure virtual

## ◆ createLocalAudioTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createLocalAudioTrackLLApiInternal | ( |  | ) |
| pure virtual

## ◆ createLocalMixedAudioTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createLocalMixedAudioTrackLLApiInternal | ( |  | ) |
| pure virtual

## ◆ createCustomAudioTrackLLApiInternal() [1/5]

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createCustomAudioTrackLLApiInternal | ( | agora_refptr< rtc::IAudioPcmDataSender > | audioSource | ) |
| pure virtual

## ◆ createDirectCustomAudioTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createDirectCustomAudioTrackLLApiInternal | ( | agora_refptr< rtc::IAudioPcmDataSender > | audioSource,
|  | bool | enableAudioProcessing
| ) |  |
| pure virtual

## ◆ createCustomAudioTrackLLApiInternal() [2/5]

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createCustomAudioTrackLLApiInternal | ( | agora_refptr< rtc::IAudioPcmDataSender > | audioSource,
|  | bool | enableAec
| ) |  |
| pure virtual

## ◆ createCustomAudioTrackLLApiInternal() [3/5]

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createCustomAudioTrackLLApiInternal | ( | agora_refptr< rtc::IRemoteAudioMixerSource > | audioSource | ) |
| pure virtual

## ◆ createCustomAudioTrackLLApiInternal() [4/5]

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createCustomAudioTrackLLApiInternal | ( | agora_refptr< rtc::IAudioEncodedFrameSender > | audioSource,
|  | TMixMode | mixMode
| ) |  |
| pure virtual

## ◆ createCustomAudioTrackLLApiInternal() [5/5]

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createCustomAudioTrackLLApiInternal | ( | agora_refptr< rtc::IMediaPacketSender > | source | ) |
| pure virtual

## ◆ createMediaPlayerAudioTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createMediaPlayerAudioTrackLLApiInternal | ( | agora_refptr< rtc::IMediaPlayerSource > | playerSource | ) |
| pure virtual

## ◆ createMediaStreamingAudioTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createMediaStreamingAudioTrackLLApiInternal | ( | agora_refptr< rtc::IMediaStreamingSource > | streamingSource | ) |
| pure virtual

## ◆ createRecordingDeviceAudioTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createRecordingDeviceAudioTrackLLApiInternal | ( | agora_refptr< rtc::IRecordingDeviceSource > | audioSource,
|  | bool | enableAec,
|  | bool | overlap
| ) |  |
| pure virtual

## ◆ createAudioDeviceManagerLLApiInternal()

virtual agora_refptr<rtc::INGAudioDeviceManager> agora::base::IAgoraServiceEx::createAudioDeviceManagerLLApiInternal | ( |  | ) |
| pure virtual

## ◆ createMediaNodeFactoryLLApiInternal()

virtual agora_refptr<rtc::IMediaNodeFactoryEx> agora::base::IAgoraServiceEx::createMediaNodeFactoryLLApiInternal | ( |  | ) |
| pure virtual

## ◆ createCameraVideoTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalVideoTrackEx> agora::base::IAgoraServiceEx::createCameraVideoTrackLLApiInternal | ( | agora_refptr< rtc::ICameraCapturer > | videoSource,
|  | const char * | track_id
| ) |  |
| pure virtual

## ◆ createMixedVideoTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalVideoTrackEx> agora::base::IAgoraServiceEx::createMixedVideoTrackLLApiInternal | ( | agora_refptr< rtc::IVideoMixerSource > | videoSource,
|  | const char * | id
| ) |  |
| pure virtual

## ◆ createTranscodedVideoTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalVideoTrackEx> agora::base::IAgoraServiceEx::createTranscodedVideoTrackLLApiInternal | ( | agora_refptr< rtc::IVideoFrameTransceiver > | transceiver,
|  | const char * | id
| ) |  |
| pure virtual

## ◆ createCustomVideoTrackLLApiInternal() [1/3]

virtual agora_refptr<rtc::ILocalVideoTrackEx> agora::base::IAgoraServiceEx::createCustomVideoTrackLLApiInternal | ( | agora_refptr< rtc::IVideoFrameSender > | videoSource,
|  | const char * | id
| ) |  |
| pure virtual

## ◆ createCustomVideoTrackLLApiInternal() [2/3]

virtual agora_refptr<rtc::ILocalVideoTrackEx> agora::base::IAgoraServiceEx::createCustomVideoTrackLLApiInternal | ( | agora_refptr< rtc::IVideoEncodedImageSender > | videoSource,
|  | const rtc::SenderOptions & | options,
|  | const char * | id = `nullptr`
| ) |  |
| pure virtual

## ◆ createCustomVideoTrackLLApiInternal() [3/3]

virtual agora_refptr<rtc::ILocalVideoTrackEx> agora::base::IAgoraServiceEx::createCustomVideoTrackLLApiInternal | ( | agora_refptr< rtc::IMediaPacketSender > | source,
|  | const char * | id = `nullptr`
| ) |  |
| pure virtual

## ◆ createScreenCaptureVideoTrackLLApiInternal() [1/2]

virtual agora_refptr<rtc::ILocalVideoTrackEx> agora::base::IAgoraServiceEx::createScreenCaptureVideoTrackLLApiInternal | ( | agora_refptr< rtc::IScreenCapturer2 > | screen | ) |
| pure virtual

## ◆ createScreenCaptureVideoTrackLLApiInternal() [2/2]

virtual agora_refptr<rtc::ILocalVideoTrackEx> agora::base::IAgoraServiceEx::createScreenCaptureVideoTrackLLApiInternal | ( | agora_refptr< rtc::IScreenCapturer > | screen,
|  | const char * | id
| ) |  |
| pure virtual

## ◆ createScreenCaptureAudioTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalAudioTrackEx> agora::base::IAgoraServiceEx::createScreenCaptureAudioTrackLLApiInternal | ( | agora_refptr< ScreenCaptureType > | screen | ) |
| pure virtual

## ◆ createMediaPlayerVideoTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalVideoTrackEx> agora::base::IAgoraServiceEx::createMediaPlayerVideoTrackLLApiInternal | ( | agora_refptr< rtc::IMediaPlayerSource > | playerVideoSource,
|  | const char * | id = `nullptr`
| ) |  |
| pure virtual

## ◆ createMediaStreamingVideoTrackLLApiInternal()

virtual agora_refptr<rtc::ILocalVideoTrackEx> agora::base::IAgoraServiceEx::createMediaStreamingVideoTrackLLApiInternal | ( | agora_refptr< rtc::IMediaStreamingSource > | streamingSource,
|  | const char * | id = `nullptr`
| ) |  |
| pure virtual

## ◆ createRtmpStreamingServiceLLApiInternal()

virtual agora_refptr<rtc::IRtmpStreamingService> agora::base::IAgoraServiceEx::createRtmpStreamingServiceLLApiInternal | ( | agora_refptr< rtc::IRtcConnection > | rtcConnection,
|  | const char * | appId
| ) |  |
| pure virtual

## ◆ createMediaRelayServiceLLApiInternal()

virtual agora_refptr<rtc::IMediaRelayService> agora::base::IAgoraServiceEx::createMediaRelayServiceLLApiInternal | ( | agora_refptr< rtc::IRtcConnection > | rtcConnection,
|  | const char * | appId
| ) |  |
| pure virtual

## ◆ createAudioDeviceManagerComponentLLApiInternal()

virtual agora_refptr<rtc::IAudioDeviceManager> agora::base::IAgoraServiceEx::createAudioDeviceManagerComponentLLApiInternal | ( | rtc::IAudioDeviceManagerObserver * | observer | ) |
| pure virtual

## ◆ createFileUploadServiceLLApiInternal()

virtual agora_refptr<rtc::IFileUploaderService> agora::base::IAgoraServiceEx::createFileUploadServiceLLApiInternal | ( | agora_refptr< rtc::IRtcConnection > | rtcConnection,
|  | const char * | appId
| ) |  |
| pure virtual

## ◆ createLocalDataChannelLLApiInternal()

virtual agora_refptr<ILocalDataChannel> agora::base::IAgoraServiceEx::createLocalDataChannelLLApiInternal | ( | const DataChannelConfig & | config | ) |
| pure virtual

## ◆ getConfigCenterLLApiInternal()

virtual agora_refptr<rtc::IConfigCenter> agora::base::IAgoraServiceEx::getConfigCenterLLApiInternal | ( |  | ) |
| pure virtual

## ◆ createSyncClientLLApiInternal()

virtual agora_refptr<base::ISyncClientEx> agora::base::IAgoraServiceEx::createSyncClientLLApiInternal | ( | const SyncConfig & | config | ) |
| pure virtual

## ◆ addExtensionObserverLLApiInternal()

virtual int agora::base::IAgoraServiceEx::addExtensionObserverLLApiInternal | ( | agora::agora_refptr< agora::rtc::IMediaExtensionObserver > | observer | ) |
| pure virtual

## ◆ removeExtensionObserverLLApiInternal()

virtual int agora::base::IAgoraServiceEx::removeExtensionObserverLLApiInternal | ( | agora::agora_refptr< agora::rtc::IMediaExtensionObserver > | observer | ) |
| pure virtual

## ◆ getExtensionIdLLApiInternal()

virtual const char* agora::base::IAgoraServiceEx::getExtensionIdLLApiInternal | ( | const char * | provider_name,
|  | const char * | extension_name
| ) |  |
| pure virtual

## ◆ enableExtensionLLApiInternal()

virtual int agora::base::IAgoraServiceEx::enableExtensionLLApiInternal | ( | const char * | provider_name,
|  | const char * | extension_name,
|  | const char * | track_id,
|  | bool | auto_enable_on_track
| ) |  |
| pure virtual

## ◆ disableExtensionLLApiInternal()

virtual int agora::base::IAgoraServiceEx::disableExtensionLLApiInternal | ( | const char * | provider_name,
|  | const char * | extension_name,
|  | const char * | track_id
| ) |  |
| pure virtual

## ◆ startTrace()

virtual int agora::base::IAgoraServiceEx::startTrace | ( | uint32_t | count,
|  | uint64_t | mask
| ) |  |
| pure virtual

Start trace with mask and max ring buffer size: count.

Returns

- -1: Service don't start or start trace failure.
- 1: Success, and do nothing if it already started.

## ◆ stopTrace()

virtual int agora::base::IAgoraServiceEx::stopTrace | ( | const char * | file_path | ) |
| pure virtual

stop trace, and save log in file_path.

Returns

- -1: Service don't start
- 1: Success, and do nothing if it already stoped

## ◆ setExternalAudioSink()

virtual int agora::base::IAgoraServiceEx::setExternalAudioSink | ( | bool | enabled,
|  | int | sampleRate,
|  | int | channels
| ) |  |
| pure virtual

Sets the external audio sink.

This method applies to scenarios where you want to use external audio data for playback.

Parameters

  enabled | true: Enables the external audio sink. false: Disables the external audio sink.
  sampleRate | Sets the sample rate (Hz) of the external audio sink, which can be set as 16000, 32000, 44100 or 48000.
  channels | Sets the number of audio channels of the external audio sink: 1: Mono. 2: Stereo.

Returns
  - 0: Success.
  - < 0: Failure.

## ◆ pullPlaybackAudioPcmData()

virtual int agora::base::IAgoraServiceEx::pullPlaybackAudioPcmData | ( | void * | payloadData,
|  | const rtc::AudioPcmDataInfo & | audioFrameInfo
| ) |  |
| pure virtual

Pulls the playback PCM audio data from all the channel.

Parameters

  [out] | payloadData | The pointer to the playback PCM audio data.
  [in] | audioFrameInfo | The reference to the information of the PCM audio data: AudioPcmDataInfo.

Returns
  - 0: Success.
  - < 0: Failure.

## ◆ createRhythmPlayer()

virtual aosl_ref_t agora::base::IAgoraServiceEx::createRhythmPlayer | ( |  | ) |
| pure virtual

## ◆ destroyRhythmPlayer()

virtual int agora::base::IAgoraServiceEx::destroyRhythmPlayer | ( | aosl_ref_t | ref_id | ) |
| pure virtual

## ◆ createMediaPlayer()

virtual aosl_ref_t agora::base::IAgoraServiceEx::createMediaPlayer | ( | media::base::MEDIA_PLAYER_SOURCE_TYPE | type | ) |
| pure virtual

## ◆ destroyMediaPlayer()

virtual int agora::base::IAgoraServiceEx::destroyMediaPlayer | ( | aosl_ref_t | ref_id | ) |
| pure virtual

## ◆ unregisterServiceEventObserver()

virtual int agora::base::IAgoraServiceEx::unregisterServiceEventObserver | ( | IServiceObserver * | observer | ) |
| pure virtual

## ◆ getIoEngine()

virtual commons::io_engine_base* agora::base::IAgoraServiceEx::getIoEngine | ( |  | ) |
| pure virtual

## ◆ setExternalRemoteEglContext()

virtual int agora::base::IAgoraServiceEx::setExternalRemoteEglContext | ( | void * | eglContext | ) |
| pure virtual

Set remote eglContext.

When engine destroy, the SDK will automatically release the eglContext internally.

Parameters

  eglContext. |

Note
  setExternalRemoteEglContext needs to be called before joining the channel.

Returns
  - 0: Success.
  - < 0: Failure.

## ◆ initialize() [2/2]

virtual int agora::base::IAgoraService::initialize

Initializes the AgoraService object.

Parameters

  config | The configuration of the initialization. For details, see AgoraServiceConfiguration.

Returns
  - 0: Success.
  - < 0: Failure.
    - `ERR_INVALID_ARGUMENT`, if `context` in `AgoraServiceConfiguration` is not provided for Android.
    - `ERR_INIT_NET_ENGINE`, if the network engine cannot be initialized. On Windows, the error occurs mostly because the connection to the local port is disabled by the firewall. In this case, turn off the firewall and then turn it on again.